function WG.Character.Power.Updated ( eventCode , unitTag, powerIndex, powerType, powerCurrent, powerMax, powerEffMax )	
	if ( unitTag == "player" ) then
		if ( powerType == POWERTYPE_HEALTH ) then
			current, max, effMax = GetUnitPower  ( "player" , POWERTYPE_HEALTH)
			WG.Character.Health_Label:SetText    ( string.format ( " %d / %d", current, effMax ) )
			WG.Character.Health_Bar:SetValue     ( current / effMax * 100 )
			WG.Character.Health_Percent:SetText  ( string.format ( "%d%%" , current / effMax * 100 ) )
			WG.Health = current / effMax * 100
		elseif ( powerType == POWERTYPE_MAGICKA ) then
			current, max, effMax = GetUnitPower  ("player", POWERTYPE_MAGICKA)
			WG.Character.Magicka_Label:SetText   ( string.format ( " %d / %d", current, effMax ) )
			WG.Character.Magicka_Bar:SetValue    ( current / effMax * 100 )
			WG.Character.Magicka_Percent:SetText ( string.format ( "%d%%" , current / effMax * 100 ) )	
			WG.Magicka = current / effMax * 100
		elseif ( powerType == POWERTYPE_STAMINA ) then
			current, max, effMax = GetUnitPower  ( "player", POWERTYPE_STAMINA)
			WG.Character.Stamina_Label:SetText   ( string.format ( " %d / %d", current, effMax ) )
			WG.Character.Stamina_Bar:SetValue    ( current / effMax * 100 )
			WG.Character.Stamina_Percent:SetText ( string.format ( "%d%%" , current / effMax * 100 ) )
			WG.Stamina = current / effMax * 100
		elseif ( powerType == POWERTYPE_MOUNT_STAMINA ) then
			current , max , effMax = GetUnitPower ( "player" , POWERTYPE_MOUNT_STAMINA )
			WG.Character.Mount_Stamina:SetValue ( current / effMax * 100 )
			WG.MountStamina = current / effMax * 100
		else return end
	elseif ( string.find ( unitTag , "group" )  and powerType == POWERTYPE_HEALTH ) then
		WG.Group.Update ( GetGroupSize() )
	elseif ( unitTag == "reticleover" and powerType == POWERTYPE_HEALTH ) then
		WG.Character.Target.Changed()
	end
	
	ZO_PlayerAttribute:SetHidden( true )
end

function WG.Character.CombatFade ()
	if ( not WG.AlreadyLoaded ) then return end
	if ( not WG.Save.Player.Stats.Fade.Enabled ) then return end
	
	WG.Character.Stat_Frame:SetAlpha ( WG.Save.Player.Stats.Alpha )
	WG.Character.Player_Frame:SetAlpha ( WG.Save.Player.Level.Alpha )

	
	
	if ( WG.Health >= 100 and WG.Magicka >= 100 and WG.Stamina >= 100 and WG.MountStamina >= 100 and not IsUnitInCombat ( "player" ) ) then
		WG.Character.Stat_Frame:SetAlpha ( WG.Save.Player.Stats.Fade.Alpha )
		WG.Character.Player_Frame:SetAlpha ( WG.Save.Player.Stats.Fade.Alpha )
	end
end

function WG.Character.Level.Updated ( eventCode , unitTag , level )
	if ( unitTag ~= "player" ) then return end
	
	if ( not IsUnitVeteran ( unitTag ) ) then
		WG.Character.Player_Label:SetText ( string.format ( GetUnitName ( unitTag ) .. " (%d)" , level ) )
	else
		WG.Character.Player_Label:SetText ( string.format ( "Veteran " .. GetUnitName ( unitTag ) .. " (Rank %d)" , level ) )
	end
end

function WG.Character.Target.Changed ( ... )

	if ( WG.Save.Target.Stats.Hidden ) then return end
	if ( GetUnitPower ( "reticleover" , POWERTYPE_HEALTH ) == 0 ) then
		WG.Character.Target_Frame:SetHidden ( true )
	else
		WG.Character.Target_Frame:SetHidden ( false )
		current, max, effMax = GetUnitPower  ( "reticleover" , POWERTYPE_HEALTH)
		WG.Character.Target_Label:SetText    ( string.format ( " %d / %d", current, effMax ) )
		WG.Character.Target_Bar:SetValue     ( current / effMax * 100 )
		WG.Character.Target_Percent:SetText  ( string.format ( "%d%%" , current / effMax * 100 ) )
		WG.Character.Target_Name_Label:SetText ( string.format( GetUnitName ( "reticleover" ) .. " (%d)" , GetUnitLevel ( "reticleover" ) ) )
		WG.Character.Target_Class:SetTexture ( WG.Character.Class ( "reticleover" ) )		
	end
	 WG.Reaction = GetUnitReaction ( "reticleover" )
	if ( WG.Reaction == UNIT_REACTION_HOSTILE ) then
		color = WG.Save.Target.Stats.Hostile
		WG.Character.Target_Name_Label:SetColor ( color[1] , color[2] , color[3] , color[4] )
	elseif ( WG.Reaction == UNIT_REACTION_NEUTRAL )then
		color = WG.Save.Target.Stats.Neutral
		WG.Character.Target_Name_Label:SetColor ( color[1] , color[2] , color[3] , color[4] )
	elseif ( WG.Reaction == UNIT_REACTION_FRIENDLY or WG.Reaction == UNIT_REACTION_NPC_ALLY or WG.Reaction == UNIT_REACTION_PLAYER_ALLY ) then
		color = WG.Save.Target.Stats.Friendly
		WG.Character.Target_Name_Label:SetColor ( color[1] , color[2] , color[3] , color[4] )
	else
		color = { 1 , 1 , 1 , 1 } 
		WG.Character.Target_Name_Label:SetColor ( color[1] , color[2] , color[3] , color[4] )
	end
	
	if ( WG.Save.Target.Stats.Icon.Hidden ) then return end
	WG.Difficulty = GetUnitDifficulty ( "reticleover" )
	
	if ( WG.Difficulty == MONSTER_DIFFICULTY_NONE ) then
		WG.Character.Target_Difficulty:SetHidden ( false )
		WG.Character.Target_Difficulty:SetTexture ( "WarGenesisAddon/Art/Difficulty_None.dds" )
	elseif ( WG.Difficulty == MONSTER_DIFFICULTY_EASY ) then
		WG.Character.Target_Difficulty:SetHidden ( false )
		WG.Character.Target_Difficulty:SetTexture ( "WarGenesisAddon/Art/Difficulty_Easy.dds" )
	elseif ( WG.Difficulty == MONSTER_DIFFICULTY_NORMAL ) then
		WG.Character.Target_Difficulty:SetHidden ( false )
		WG.Character.Target_Difficulty:SetTexture ( "WarGenesisAddon/Art/Difficulty_Normal.dds" )
	elseif ( WG.Difficulty == MONSTER_DIFFICULTY_HARD ) then
		WG.Character.Target_Difficulty:SetHidden ( false )
		WG.Character.Target_Difficulty:SetTexture ( "WarGenesisAddon/Art/Difficulty_Hard.dds" )
	elseif ( WG.Difficulty == MONSTER_DIFFICULTY_DEADLY ) then
		WG.Character.Target_Difficulty:SetHidden ( false )
		WG.Character.Target_Difficulty:SetTexture ( "WarGenesisAddon/Art/Difficulty_Deadly.dds" )
	else
		WG.Character.Target_Difficulty:SetHidden ( true )
	end
	
end

function WG.Character.Class ( unitTag )
	if (unitTag == "player" or unitTag == "reticleover" or string.find ( unitTag , "group" ) ) then
		local myClass = GetUnitClass ( unitTag )
		return "ESOUI/art/contacts/social_classicon_".. myClass ..".dds"
	end
end

function WG.Character.DeathState ( eventCode , unitTag , isDead )
	if ( string.find ( unitTag , "group" ) ) then
		GROUP_LIST:BuildMasterList()
	
		groupCount = GetGroupSize()
		if ( groupCount == 0 ) then return end
	
		if (groupCount <= 4 ) then
			for x = 1 , groupCount , 1 do			
				if ( IsUnitDead ( GROUP_LIST.masterList[x].unitTag ) ) then
					WG.Group.Party[x].DeathIcon:SetHidden ( false )
				else
					WG.Group.Party[x].DeathIcon:SetHidden ( true )
				end
			end
		else
			for x = 1 , groupCount , 1 do
				if ( IsUnitDead ( GROUP_LIST.masterList[x].unitTag ) ) then
					WG.Group.Raid[x].DeathIcon:SetHidden ( false )
				else
					WG.Group.Raid[x].DeathIcon:SetHidden ( true )
				end
			end
		end
	elseif ( unitTag == "player" ) then
		
		WG.Character.DeathIcon:SetHidden ( not isDead )
	end
end

function WG.Character.MountState ( eventCode , isMounted )
	WG.Character.Mount_Stamina:SetHidden ( not isMounted )
	WG.Character.Mount_Back:SetHidden    ( not isMounted )
	WG.Character.Mount_Icon:SetHidden    ( not isMounted )
end

function WG.Character.CombatState ( eventCode , inCombat )
	WG.CombatState = inCombat
end

function WG.Character.GetTime()
	WG.Character.Clock_Time:SetText ( GetTimeString() )
end