function WG.Group.Controls()
	
	-- Create the Raid Frame
	WG.Group.Raid.Frame  = WG.UI.TopLevelWindow ( "Raid_Frame"      , nil                 , { 400 , 460 } , { WG.Save.Group.Raid.Point , nil       , WG.Save.Group.Raid.OffsetX   , WG.Save.Group.Raid.OffsetY  }     , WG.Save.Group.Raid.Hidden , "Group" , "Raid" )
		
	local offsetY = 0
	local offsetX = 0
	local count = 8
	for x = 1 , 24 , 1  do 
		WG.Group.Raid[x] = {}
		WG.Group.Raid[x].Back   = WG.UI.Backdrop       ( "Raid" .. x .. "Back"       , WG.Group.Raid.Frame   , { 150 , 15 } , { nil    , TOPLEFT   , offsetX , offsetY    }     , WG.Save.Colors.Health.Back   , WG.Save.Colors.Health.Edge          , false )
		WG.Group.Raid[x].Bar    = WG.UI.Statusbar      ( "Raid" .. x .. "Bar"        , WG.Group.Raid[x].Back , { 150 , 15 } , { nil    , TOPLEFT   , 0 , 0      } , WG.Save.Colors.Health.Main            , false )
		WG.Group.Raid[x].Label  = WG.UI.Label          ( "Raid" .. x .. "Label"      , WG.Group.Raid[x].Bar  , { 150 , 20 } , { nil    , nil       , 0 , -20    } , { TEXT_ALIGN_CENTER   , TEXT_ALIGN_CENTER }    , nil , { 200 , 200 , 200 , 1 } , "(level) name 100%" , false )
		WG.Group.Raid[x].DeathIcon  = WG.UI.Texture    ( "Raid" .. x .. "DeathIcon"  , WG.Group.Raid[x].Bar  , { 25  , 25 } , { nil    , nil       , 145 , -5 }  , "WarGenesisAddon/Art/Dead.dds" , true )
		WG.Group.Raid[x].Class  = WG.UI.Texture        ( "Raid" .. x .. "Class"      , WG.Group.Raid[x].Bar  , { 25  , 25 } , { nil    , nil       , -25  , -23   } , WG.Character.Class ( "player" ) , false )
		WG.Group.Raid[x].Online = WG.UI.Texture        ( "Raid" .. x .. "Online"     , WG.Group.Raid[x].Bar  , { 25  , 25 } , { nil    , nil       , -25  , -5  } , "ESOUI/art/contacts/social_status_online.dds" , false )
		WG.Group.Raid[x].Spec   = WG.UI.Texture        ( "Raid" .. x .. "Spec"       , WG.Group.Raid[x].Bar  , { 23  , 23 } , { nil    , nil       , 150 , -25   } , "WarGenesisAddon/Art/lfg_healer_down.dds" , false )		
		
		offsetY = offsetY + 40
		if ( x == count ) then
			offsetX = offsetX + 200
			offsetY = 0
			count = count + 8
		end
		
		WG.Group.Raid[x].Bar:SetValue(85)
	end
	
	-- Create the Party Frame
	WG.Group.Party.Frame  = WG.UI.TopLevelWindow ( "Party_Frame"      , nil                 , { 400 , 460 } , { WG.Save.Group.Party.Point , nil       , WG.Save.Group.Party.OffsetX   , WG.Save.Group.Party.OffsetY  }     , WG.Save.Group.Party.Hidden , "Group" , "Party" )
	
	offsetY = 0
	
	for x = 1 , 4 , 1 do
		WG.Group.Party[x] = {}
		WG.Group.Party[x].Back  = WG.UI.Backdrop       ( "Party" .. x .. "Back"       , WG.Group.Party.Frame   , { 250 , 20 } , { nil    , TOPLEFT   , 0 , offsetY    }     , WG.Save.Colors.Health.Back   , WG.Save.Colors.Health.Edge          , true )
		WG.Group.Party[x].Bar   = WG.UI.Statusbar      ( "Party" .. x .. "Bar"        , WG.Group.Party[x].Back , { 250 , 20 } , { nil    , TOPLEFT   , 0 , 0    }     , WG.Save.Colors.Health.Main            , false )
		WG.Group.Party[x].DeathIcon  = WG.UI.Texture   ( "Party" .. x .. "DeathIcon"  , WG.Group.Party[x].Bar  , { 30  , 30 } , { nil    , nil       , 250 , -5 }  , "WarGenesisAddon/Art/Dead.dds" , true )
		WG.Group.Party[x].Stats = WG.UI.Label          ( "Party" .. x .. "Stats"      , WG.Group.Party[x].Bar  , { 250 , 20 } , { nil    , nil       , 0 , -2   }     , { TEXT_ALIGN_LEFT   , TEXT_ALIGN_CENTER }    , nil , { 200 , 200 , 200 , 1 } , "1000 / 1000" , true )
		WG.Group.Party[x].Percent = WG.UI.Label        ( "Party" .. x .. "Percent"    , WG.Group.Party[x].Bar  , { 250 , 20 } , { nil    , nil       , 0 , -2   }     , { TEXT_ALIGN_RIGHT   , TEXT_ALIGN_CENTER }    , nil , { 200 , 200 , 200 , 1 } , "100%" , true )
		WG.Group.Party[x].Name = WG.UI.Label           ( "Party" .. x .. "Name"       , WG.Group.Party[x].Bar  , { 250 , 20 } , { nil    , nil       , 0 , -25   }     , { TEXT_ALIGN_CENTER   , TEXT_ALIGN_CENTER }    , nil , { 200 , 200 , 200 , 1 } , "(25) Ultimus Thee Greater Fool 100%" , true )
		WG.Group.Party[x].Class = WG.UI.Texture        ( "Party" .. x .. "Class"      , WG.Group.Party[x].Bar  , { 30  , 30 } , { nil    , nil       , 0 , -30   } , WG.Character.Class ( "player" ) , false )
		WG.Group.Party[x].Online = WG.UI.Texture       ( "Party" .. x .. "Online"     , WG.Group.Party[x].Bar  , { 25  , 25 } , { nil    , nil       , -25  , -3  } , "ESOUI/art/contacts/social_status_online.dds" , false )
		WG.Group.Party[x].Spec   = WG.UI.Texture       ( "Party" .. x .. "Spec"       , WG.Group.Party[x].Bar  , { 25  , 25 } , { nil    , nil       , 230 , -27   } , "WarGenesisAddon/Art/lfg_healer_down.dds" , false )
		
		offsetY = offsetY + 75
	end
end