function WG.Group.Joined ( ... )
	if ( WG.Save.Group.Party.Hidden ) then return end
	
	GROUP_LIST:BuildMasterList()
	
	local groupCount = GetGroupSize()
	if ( groupCount == 0 or groupCount == nil ) then return end
	
	if ( groupCount <= 4 ) then
		WG.Group.Party.Frame:SetHidden ( false )
		
		for x = 1 , groupCount , 1 do
			WG.Group.Party[x].Back:SetHidden ( false )
			WG.Group.Party[x].Bar:SetHidden ( false )
			WG.Group.Party[x].Stats:SetHidden ( false )
			WG.Group.Party[x].Percent:SetHidden ( false )
			WG.Group.Party[x].Name:SetHidden ( false )
			WG.Group.Party[x].Class:SetHidden ( false )
		end
	else
		WG.Group.Raid.Frame:SetHidden ( false )
		
		for x = 1 , groupCount , 1 do
			WG.Group.Raid[x].Back:SetHidden  ( false )
			WG.Group.Raid[x].Bar:SetHidden   ( false )
			WG.Group.Raid[x].Label:SetHidden ( false )
			WG.Group.Raid[x].Class:SetHidden ( false )
		end
	end
	
	WG.Group.Update ( groupCount )
	WG.Group.PlayerSpec()
end

function WG.Group.Left ( ... )
	if ( WG.Save.Group.Party.Hidden ) then return end
	
		WG.Group.Raid.Frame:SetHidden ( true )
		WG.Group.Party.Frame:SetHidden ( true )
		
		for x = 1 , 4 , 1 do
			WG.Group.Party[x].Back:SetHidden ( true )
			WG.Group.Party[x].Bar:SetHidden ( true )
			WG.Group.Party[x].Stats:SetHidden ( true )
			WG.Group.Party[x].Percent:SetHidden ( true )
			WG.Group.Party[x].Name:SetHidden ( true )
			WG.Group.Party[x].Class:SetHidden ( true )
		end
		
		for x = 1 , 24 , 1 do
			WG.Group.Raid[x].Back:SetHidden  ( true )
			WG.Group.Raid[x].Bar:SetHidden   ( true )
			WG.Group.Raid[x].Label:SetHidden ( true )
			WG.Group.Raid[x].Class:SetHidden ( true )
		end
		
		WG.Group.Joined()
end

function WG.Group.Update ( groupCount )
	if ( WG.Save.Group.Party.Hidden ) then return end
	if ( groupCount == nil or groupCount == 0 ) then return end
	
	if ( groupCount <= 4 ) then
		for x = 1 , groupCount , 1 do
			current , max , effMax = GetUnitPower ( GROUP_LIST.masterList[x].unitTag , POWERTYPE_HEALTH )
				
			WG.Group.Party[x].Bar:SetValue ( current / effMax * 100 )
			WG.Group.Party[x].Stats:SetText ( string.format ( "%d / %d" , current , effMax ) )
			WG.Group.Party[x].Percent:SetText ( string.format ( "%d%%" , current / effMax * 100 ) )
			WG.Group.Party[x].Name:SetText ( string.format ( GROUP_LIST.masterList[x].characterName .. " (%d)" , GetUnitLevel ( GROUP_LIST.masterList[x].unitTag ) ) ) 
			WG.Group.Party[x].Class:SetTexture ( WG.Character.Class ( GROUP_LIST.masterList[x].unitTag ) )
			
			if ( GROUP_LIST.masterList[x].leader ) then
				color = rgbFix ( { 1 , 140 , 255 , 1 } )
				WG.Group.Party[x].Name:SetColor ( color[1] , color[2] , color[3] , color[4] ) 
			else
				color = rgbFix ( { 200 , 200 , 200 , 1 } )
				WG.Group.Party[x].Name:SetColor ( color[1] , color[2] , color[3] , color[4] )
			end
		end
	else
		for x = 1 , groupCount , 1 do
			current , max , effMax = GetUnitPower ( GROUP_LIST.masterList[x].unitTag , POWERTYPE_HEALTH )
			WG.Group.Raid[x].Bar:SetValue ( current / effMax * 100 )
			WG.Group.Raid[x].Label:SetText ( string.format ( "(%d) " .. GROUP_LIST.masterList[x].characterName .. " %d%%" , GetUnitLevel ( GROUP_LIST.masterList[x].unitTag ) , current / effMax * 100 ) )
			WG.Group.Raid[x].Class:SetTexture ( WG.Character.Class ( GROUP_LIST.masterList[x].unitTag ) )
			
			if ( GROUP_LIST.masterList[x].leader ) then
				color = rgbFix ( { 1 , 140 , 255 , 1 } )
				WG.Group.Raid[x].Label:SetColor ( color[1] , color[2] , color[3] , color[4] ) 
			else
				color = rgbFix ( { 200 , 200 , 200 , 1 } )
				WG.Group.Raid[x].Label:SetColor ( color[1] , color[2] , color[3] , color[4] ) 
			end
		end
	end
	
	WG.Group.OnlineStatus()
end

function WG.Group.LeaderChanged ( ... )
	if ( WG.Save.Group.Party.Hidden ) then return end
	
	GROUP_LIST:BuildMasterList()
	
	groupCount = GetGroupSize()
	if ( groupCount == 0 ) then return end
	
	if (groupCount <= 4 ) then
		for x = 1 , groupCount , 1 do			
			if ( GROUP_LIST.masterList[x].leader ) then
				color = rgbFix ( { 1 , 140 , 255 , 1 } )
				WG.Group.Party[x].Name:SetColor ( color[1] , color[2] , color[3] , color[4] ) 
			else
				color = rgbFix ( { 200 , 200 , 200 , 1 } )
				WG.Group.Party[x].Name:SetColor ( color[1] , color[2] , color[3] , color[4] )
			end
		end
	else
		for x = 1 , groupCount , 1 do
			if ( GROUP_LIST.masterList[x].leader ) then
				color = rgbFix ( { 1 , 140 , 255 , 1 } )
				WG.Group.Raid[x].Label:SetColor ( color[1] , color[2] , color[3] , color[4] ) 
			else
				color = rgbFix ( { 200 , 200 , 200 , 1 } )
				WG.Group.Raid[x].Label:SetColor ( color[1] , color[2] , color[3] , color[4] ) 
			end
		end
	end
end

function WG.Group.OnlineStatus( ... )
	if ( WG.Save.Group.Party.Hidden ) then return end
	
	GROUP_LIST:BuildMasterList()
	
	groupCount = GetGroupSize()
	if ( groupCount == 0 ) then return end
	
	if (groupCount <= 4 ) then
		for x = 1 , groupCount , 1 do			
			if ( GROUP_LIST.masterList[x].online ) then
				WG.Group.Party[x].Online:SetTexture ( "ESOUI/art/contacts/social_status_online.dds" )
			else
				WG.Group.Party[x].Online:SetTexture ( "ESOUI/art/contacts/social_status_offline.dds" )
			end
		end
	else
		for x = 1 , groupCount , 1 do
			if ( GROUP_LIST.masterList[x].online ) then
				WG.Group.Raid[x].Online:SetTexture ( "ESOUI/art/contacts/social_status_online.dds" )
			else
				WG.Group.Raid[x].Online:SetTexture ( "ESOUI/art/contacts/social_status_offline.dds" )
			end
		end
	end
end

function WG.Group.PlayerSpec( ... )
	if ( WG.Save.Group.Party.Hidden ) then return end
	GROUP_LIST:BuildMasterList()
	
	groupCount = GetGroupSize()
	if ( groupCount == 0 ) then return end
	
	if (groupCount <= 4 ) then
		for x = 1 , groupCount , 1 do			
			if ( GROUP_LIST.masterList[x].isDps ) then
				WG.Group.Party[x].Spec:SetTexture ( "WarGenesisAddon/Art/lfg_dps_down.dds" )
			elseif ( GROUP_LIST.masterList[x].isHeal ) then
				WG.Group.Party[x].Spec:SetTexture ( "WarGenesisAddon/Art/lfg_healer_down.dds" )
			elseif ( GROUP_LIST.masterList[x].isTank ) then
				WG.Group.Party[x].Spec:SetTexture ( "WarGenesisAddon/Art/lfg_tank_down.dds" )
			end
		end
	else
		for x = 1 , groupCount , 1 do
			if ( GROUP_LIST.masterList[x].isDps ) then
				WG.Group.Raid[x].Spec:SetTexture ( "WarGenesisAddon/Art/lfg_dps_down.dds" )
			elseif ( GROUP_LIST.masterList[x].isHeal ) then
				WG.Group.Raid[x].Spec:SetTexture ( "WarGenesisAddon/Art/lfg_healer_down.dds" )
			elseif ( GROUP_LIST.masterList[x].isTank ) then
				WG.Group.Raid[x].Spec:SetTexture ( "WarGenesisAddon/Art/lfg_tank_down.dds" )
			end
		end
	end
end