local WGDoneLoading = false

function WG.OnMoveStop ( self , table1, table2 )
	WG.Save[table1][table2].Point   = TOPLEFT
	WG.Save[table1][table2].OffsetX = self:GetLeft()
	WG.Save[table1][table2].OffsetY = self:GetTop()
end

function WG.OnReticleUpdate ( eventCode , hidden )

	WG.Character.Stat_Frame:SetHidden        ( hidden )
	WG.Character.Player_Frame:SetHidden      ( hidden )
	WG.Group.Raid.Frame:SetHidden            ( hidden )
	WG.Group.Party.Frame:SetHidden           ( hidden )
	WG.XP.XP_Frame:SetHidden                 ( hidden )
	WG.XP.XP_Hour_Frame:SetHidden            ( hidden )
	WG.Character.Target_Frame:SetHidden      ( true )	
	WG.Character.Clock_Frame:SetHidden       ( hidden )
	
	if ( not hidden ) then 
		WG.framesLocked = true
		WG.Settings.Changed()
	end	
	
	if ( not WG.Save.Target.Stats.Hidden ) then
		WG.Character.Target.Changed ( )
	else
		WG.Character.Target_Frame:SetHidden  ( true )
	end
end

function WG.LockFrames ( hidden )
	WG.Character.Stat_Frame:SetHidden        ( hidden )
	WG.Character.Player_Frame:SetHidden      ( hidden )
	WG.Group.Raid.Frame:SetHidden            ( hidden )
	WG.Group.Party.Frame:SetHidden           ( hidden )
	WG.XP.XP_Frame:SetHidden                 ( hidden )
	WG.XP.XP_Hour_Frame:SetHidden            ( hidden )
	WG.Character.Target_Frame:SetHidden      ( hidden )
	ZO_ActionBar1:SetHidden                  ( hidden )
	WG.Character.Clock_Frame:SetHidden       ( hidden )
end

function WG.AddonLoaded ( eventCode , addonName )
	if ( addonName ~= "WarGenesisAddon" ) then return end
	
	WG.Defaults = {
		["XP"] = {
			["Stats"] = {
				["Point"]   = BOTTOM ,
				["OffsetX"] = 0 ,
				["OffsetY"] = -90 , 
				["Alpha"]   = 1 ,
				["Hidden"]  = false 				
				} ,
			["Hourly"]  = {
				["Point"]   = BOTTOM ,
				["OffsetX"] = 0 ,
				["OffsetY"] = -120 ,
				["Alpha"]   = 1 ,
				["Hidden"]  = false 				 
				}
			} ,
		["Player"] = {
			["Stats"] = {
				["Point"]   = CENTER , 
				["OffsetX"] = -400 ,
				["OffsetY"] = 0 ,
				["Alpha"]   = 1 ,
				["Hidden"]  = false ,
				["Size"]    = {
					["X"] = 260 ,
					["Y"] = 20
					} ,
				["Fade"]    = {
					["Enabled"]  = true ,
					["Alpha"] = 0.1
					}
				} ,
			["Level"] = {
				["Point"]   = CENTER ,
				["OffsetX"] = -400 , 
				["OffsetY"] = -50 ,
				["Hidden"]  = false ,
				["Alpha"]   = 1
				} ,
			} ,
		["Target"] = {
			["Stats"] = {
				["Point"]   = CENTER ,
				["OffsetX"] = 400 ,
				["OffsetY"] = -23 ,
				["Alpha"]   = 1 , 
				["Hidden"]  = false ,
				["Size"]    = {
					["X"] = 260 ,
					["Y"] = 20
					} ,
				["Hostile"] = { .78 , 0 , 0 , 1 } ,
				["Neutral"] = { .93 , .93 , 0 , 1 } ,
				["Friendly"] = { 0 , .86 , 0 , 1 } ,
				["Icon"] = {
					["Size"] = 50 ,
					["Alpha"] = 0.6 ,
					["Hidden"] = false
					}				
				} ,
			} ,
		["Group"] = {
			["Party"] = {
				["Point"]   = TOP ,
				["OffsetX"] = -600 ,
				["OffsetY"] = 100 ,
				["Alpha"]   = 1 ,
				["Hidden"]  = false
				} ,
			["Raid"] = {
				["Point"] = TOP ,
				["OffsetX"] = -600 ,
				["OffsetY"] = 100 ,
				["Alpha"] = 1 ,
				["Hidden"] = true
				}
			} ,
		["Colors"] = {
			["Health"] = {
				["Main"] = COLOR_HEALTH ,
				["Back"] = COLOR_HEALTH_BACKDROP ,
				["Edge"] = COLOR_HEALTH_EDGE
				} ,
			["Magicka"] = {
				["Main"] = COLOR_MAGICKA ,
				["Back"] = COLOR_MAGICKA_BACKDROP ,
				["Edge"] = COLOR_MAGICKA_EDGE
				} ,
			["Stamina"] = {
				["Main"] = COLOR_STAMINA ,
				["Back"] = COLOR_STAMINA_BACKDROP ,
				["Edge"] = COLOR_STAMINA_EDGE
				} ,
			["XP"] = {
				["Main"] = COLOR_XP ,
				["Back"] = COLOR_XP_BACKDROP ,
				["Edge"] = COLOR_XP_EDGE
				}
			} ,
		["Default"] = {
			["Target"] = false ,
			["Party"] =  false
			} , 
		["Clock"] = {
			["Pos"] = {
				["Point"] = TOPRIGHT ,
				["OffsetX"] = -75 ,
				["OffsetY"] = 20 ,
				["Hidden"] = false
				}
			}				
		}
	
	WG.Save = ZO_SavedVars:New ( "WGAO" , 30 , nil , WG.Defaults , nil )	
end

function WG.PlayerLoaded ( ... )
	if (WG.AlreadyLoaded) then return end
	
	WG.framesLocked = true
	WG.GroupSize = GetGroupSize()
	WG.Character.Controls()	
	WG.XP.Controls()
	WG.Group.Controls()
	
	startXp = GetUnitXPMax( "player" ) - GetUnitXP( "player" )
	timeStart = GetGameTimeMilliseconds()
	
	WG.Character.Power.Updated ( 0 , "player" , 0 , POWERTYPE_HEALTH  , 0 , 0 , 0 )
	WG.Character.Power.Updated ( 0 , "player" , 0 , POWERTYPE_MAGICKA , 0 , 0 , 0 )
	WG.Character.Power.Updated ( 0 , "player" , 0 , POWERTYPE_STAMINA , 0 , 0 , 0 )
	WG.Character.Power.Updated ( 0 , "player" , 0 , POWERTYPE_MOUNT_STAMINA , 0 , 0 , 0 )
	
	if ( not IsUnitVeteran ( "player" ) ) then
		WG.XP.Updated              ( 0 , "player" , GetUnitXP ( "player" ) , GetUnitXPMax ( "player" ) , 1 )
		EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_EXPERIENCE_UPDATE          , WG.XP.Updated )
	else
		WG.XP.Updated              ( 0 , "player" , GetUnitVeteranPoints ( "player" ) , GetUnitVeteranPointsMax ( "player" ) , 1 )
		EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_VETERAN_POINTS_UPDATE      , WG.XP.Updated )
	end
	
	WG.Character.Level.Updated ( 0 , "player" , GetUnitLevel ( "player" ) )
	
	WG.Group.Left()
	
	WG.Character.MountState ( 0 , IsMounted() )
		
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_POWER_UPDATE                  , WG.Character.Power.Updated )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_LEVEL_UPDATE                  , WG.Character.Level.Updated )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_VETERAN_RANK_UPDATE           , WG.Character.Level.Updated )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_RETICLE_TARGET_CHANGED        , WG.Character.Target.Changed )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_GROUP_MEMBER_LEFT             , WG.Group.Left )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_RETICLE_HIDDEN_UPDATE         , WG.OnReticleUpdate )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_LEADER_UPDATE                 , WG.Group.LeaderChanged )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_UNIT_DEATH_STATE_CHANGED      , WG.Character.DeathState )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_MOUNTED_STATE_CHANGED         , WG.Character.MountState )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_GROUP_MEMBER_ROLES_CHANGED    , WG.Group.PlayerSpec )
	EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_GROUP_MEMBER_CONNECTED_STATUS , WG.Group.OnlineStatus )
	
	-- Creates the Settings Menu
	LAM = LibStub("LibAddonMenu-1.0")
		WG.panelID = LAM:CreateControlPanel( "WarGenesisAddOn_ID", "War Genesis")
		
		LAM:AddHeader      ( WG.panelID , "WarGenesisAddOn_Name" , "version 2.0.5")
		
		LAM:AddHeader      ( WG.panelID , "WgFrames_Stuff"       , "\nFrame Preferences")
		LAM:AddCheckbox    ( WG.panelID , "LockFrames"           , "Lock Frames", "Unlock or Lock the frames to move items around.", function() return WG.framesLocked end, function() WG.framesLocked = not WG.framesLocked ZO_OptionsWindow:SetHidden(true) WG.LockFrames (  WG.framesLocked ) end, false, nil )
		
		LAM:AddHeader      ( WG.panelID , "WgColor_Picker"       , "\nBar Color Preferences")
		LAM:AddColorPicker ( WG.panelID , "WGHealthBarColor"     , "Health Bar Color" , "Choose the color of the Health bar." , function() return WG.Save.Colors.Health.Main[1] , WG.Save.Colors.Health.Main[2] , WG.Save.Colors.Health.Main[3] end , function ( c1, c2, c3 ) WG.Save.Colors.Health.Main = { c1 , c2 , c3 , .75 }  end , false , nil )
		LAM:AddColorPicker ( WG.panelID , "WGHealthBackColor"    , "Health Bar Back Color" , "Choose the color of the Health bar backdrop." , function() return WG.Save.Colors.Health.Back[1] , WG.Save.Colors.Health.Back[2] , WG.Save.Colors.Health.Back[3] end , function ( c1, c2, c3 ) WG.Save.Colors.Health.Back = { c1 , c2 , c3 , .75 } WG.Save.Colors.Health.Edge = { c1 , c2 , c3 , 0 } end , false , nil )
		
		LAM:AddColorPicker ( WG.panelID , "WGMagickaBarColor"    , "Magicka Bar Color" , "Choose the color of the Magicka bar." , function() return WG.Save.Colors.Magicka.Main[1] , WG.Save.Colors.Magicka.Main[2] , WG.Save.Colors.Magicka.Main[3] end , function ( c1, c2, c3 ) WG.Save.Colors.Magicka.Main = { c1 , c2 , c3 , .75 }  end , false , nil )
		LAM:AddColorPicker ( WG.panelID , "WGMagickaBackColor"   , "Magicka Bar Back Color" , "Choose the color of the Magicka bar backdrop." , function() return WG.Save.Colors.Magicka.Back[1] , WG.Save.Colors.Magicka.Back[2] , WG.Save.Colors.Magicka.Back[3] end , function ( c1, c2, c3 ) WG.Save.Colors.Magicka.Back = { c1 , c2 , c3 , .75 } WG.Save.Colors.Magicka.Edge = { c1 , c2 , c3 , 0 } end , false , nil )
		
		LAM:AddColorPicker ( WG.panelID , "WGStaminaBarColor"    , "Stamina Bar Color" , "Choose the color of the Stamina bar." , function() return WG.Save.Colors.Stamina.Main[1] , WG.Save.Colors.Stamina.Main[2] , WG.Save.Colors.Stamina.Main[3] end , function ( c1, c2, c3 ) WG.Save.Colors.Stamina.Main = { c1 , c2 , c3 , .75 }  end , false , nil )
		LAM:AddColorPicker ( WG.panelID , "WGStaminaBackColor"   , "Stamina Bar Back Color" , "Choose the color of the Stamina bar backdrop." , function() return WG.Save.Colors.Stamina.Back[1] , WG.Save.Colors.Stamina.Back[2] , WG.Save.Colors.Stamina.Back[3] end , function ( c1, c2, c3 ) WG.Save.Colors.Stamina.Back = { c1 , c2 , c3 , .75 } WG.Save.Colors.Stamina.Edge = { c1 , c2 , c3 , 0 } end , false , nil )
		
		LAM:AddColorPicker ( WG.panelID , "WGXPBarColor"         , "Experience Bar Color" , "Choose the color of the Experience bar." , function() return WG.Save.Colors.XP.Main[1] , WG.Save.Colors.XP.Main[2] , WG.Save.Colors.XP.Main[3] end , function ( c1, c2, c3 ) WG.Save.Colors.XP.Main = { c1 , c2 , c3 , .75 }  end , false , nil )
		LAM:AddColorPicker ( WG.panelID , "WGXPBackColor"        , "Experience Bar Back Color" , "Choose the color of the Experience bar backdrop." , function() return WG.Save.Colors.XP.Back[1] , WG.Save.Colors.XP.Back[2] , WG.Save.Colors.XP.Back[3] end , function ( c1, c2, c3 ) WG.Save.Colors.XP.Back = { c1 , c2 , c3 , .75 } WG.Save.Colors.XP.Edge = { c1 , c2 , c3 , 0 } end , false , nil )
		
		LAM:AddHeader      ( WG.panelID , "WgStat_Stuff"         , "\nStat Bar Preferences")
		LAM:AddCheckbox    ( WG.panelID , "WGStatBars"           , "Stat Bars", "Enable or disable the Health, Magicka and Stamina bars.", function() return not WG.Save.Player.Stats.Hidden end, function() WG.Save.Player.Stats.Hidden = not WG.Save.Player.Stats.Hidden WG.Settings.Changed() end, false, nil)
		LAM:AddCheckbox    ( WG.panelID , "WGLevelBar"           , "Name / Level Bar", "Enable or disable the Name, Level and class label.", function() return not WG.Save.Player.Level.Hidden end, function() WG.Save.Player.Level.Hidden = not WG.Save.Player.Level.Hidden WG.Settings.Changed() end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGStatSize"           , "Bar Size", "Adjust the Stat Bar Size", 125, 500, 1, function() return WG.Save.Player.Stats.Size.X end, function(newVal) WG.Save.Player.Stats.Size.X = newVal end, false, nil)

		LAM:AddCheckbox    ( WG.panelID , "WGCombatFade"         , "Fade Out", "Enable or disable the Health, Magicka and Stamina bars fading out when out of combat.", function() return WG.Save.Player.Stats.Fade.Enabled end, function() WG.Save.Player.Stats.Fade.Enabled = not WG.Save.Player.Stats.Fade.Enabled end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGCombatFadeVis"      , "Combat Fade Visibility", "Adjust the Combat Fade visibility", 0, 100, 1, function() return WG.Save.Player.Stats.Fade.Alpha * 100 end, function(newVal) WG.Save.Player.Stats.Fade.Alpha = newVal / 100 end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGStatVisibility"     , "Stat Visibility", "Adjust the visibility of the Health, Magicka and Stamina bars", 1, 100, 1, function() return WG.Save.Player.Stats.Alpha * 100 end, function(newVal) WG.Save.Player.Stats.Alpha = newVal / 100 end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGLevelVisibility"    , "Name / Level Visibility", "Adjust the visibility of the Name , Level and Class bar.", 1, 100, 1, function() return WG.Save.Player.Level.Alpha * 100 end, function(newVal) WG.Save.Player.Level.Alpha = newVal / 100 end, false, nil)
				
		LAM:AddHeader      ( WG.panelID , "WgXP_Stuff"           , "\nXP Bar Preferences")
		LAM:AddCheckbox    ( WG.panelID , "WGXPBar"              , "Experience Bar", "Enable or disable the Experience Bar.", function() return not WG.Save.XP.Stats.Hidden end, function() WG.Save.XP.Stats.Hidden = not WG.Save.XP.Stats.Hidden end, false, nil)
		LAM:AddCheckbox    ( WG.panelID , "XPHour"               , "Hourly Experience", "Enable or disable the XP Per Hour tracker.", function() return not WG.Save.XP.Hourly.Hidden end, function() WG.Save.XP.Hourly.Hidden = not WG.Save.XP.Hourly.Hidden end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGXPVisibility"       , "Experience Visibility", "Adjust the visibility of the XP and Hourly XP Bars", 1, 100, 1, function() return WG.Save.XP.Stats.Alpha * 100 end, function(newVal) WG.Save.XP.Stats.Alpha = newVal / 100 end, false, nil)
		
		LAM:AddHeader      ( WG.panelID , "WgTarget_Stuff"       , "\nTarget Frame Preferences")
		LAM:AddCheckbox    ( WG.panelID , "WGTargetFrame"        , "Target Frames", "Enable or disable the Target Frame", function() return not WG.Save.Target.Stats.Hidden end, function() WG.Save.Target.Stats.Hidden = not WG.Save.Target.Stats.Hidden end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGTargetSize"           , "Bar Size", "Adjust the Target Bar Size", 125, 500, 1, function() return WG.Save.Target.Stats.Size.X end, function(newVal) WG.Save.Target.Stats.Size.X = newVal end, false, nil)		
		LAM:AddCheckbox    ( WG.panelID , "WGTargetIconHidden"   , "Target Icon", "Enable or disable the Target Difficulty Icon", function() return not WG.Save.Target.Stats.Icon.Hidden end, function() WG.Save.Target.Stats.Icon.Hidden = not WG.Save.Target.Stats.Icon.Hidden end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGTargetIconSize"     , "Target Icon Size", "Adjust the size of the Target Icon.", 1, 100, 1, function() return WG.Save.Target.Stats.Icon.Size end, function(newVal) WG.Save.Target.Stats.Icon.Size = newVal end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGTargetIconVisibility" , "Target Icon Visibility", "Adjust the visibility of the Target Icon.", 1, 100, 1, function() return WG.Save.Target.Stats.Icon.Alpha * 100 end, function(newVal) WG.Save.Target.Stats.Icon.Alpha = newVal / 100 end, false, nil)
		LAM:AddSlider      ( WG.panelID , "WGTargetVisibility"   , "Target Visibility", "Adjust the visibility of the Target Frame Bar.", 1, 100, 1, function() return WG.Save.Target.Stats.Alpha * 100 end, function(newVal) WG.Save.Target.Stats.Alpha = newVal / 100 end, false, nil)
		LAM:AddColorPicker ( WG.panelID , "WGTargetHostile"      , "Target Hostile Color" , "Choose the color of the hostile target text." , function() return WG.Save.Target.Stats.Hostile[1] , WG.Save.Target.Stats.Hostile[2] , WG.Save.Target.Stats.Hostile[3] end , function ( c1, c2, c3 ) WG.Save.Target.Stats.Hostile = { c1 , c2 , c3 , 1 }  end , false , nil )
		LAM:AddColorPicker ( WG.panelID , "WGTargetNeutral"      , "Target Neutral Color" , "Choose the color of the neutral target text." , function() return WG.Save.Target.Stats.Neutral[1] , WG.Save.Target.Stats.Neutral[2] , WG.Save.Target.Stats.Neutral[3] end , function ( c1, c2, c3 ) WG.Save.Target.Stats.Neutral = { c1 , c2 , c3 , 1 }  end , false , nil )
		LAM:AddColorPicker ( WG.panelID , "WGTargetFriendly"     , "Target Friendly Color" , "Choose the color of the friendly target text." , function() return WG.Save.Target.Stats.Friendly[1] , WG.Save.Target.Stats.Friendly[2] , WG.Save.Target.Stats.Friendly[3] end , function ( c1, c2, c3 ) WG.Save.Target.Stats.Friendly = { c1 , c2 , c3 , 1 }  end , false , nil )
		
		LAM:AddHeader      ( WG.panelID , "WGGroupStuff"         , "\nGroup Preferences")
		LAM:AddCheckbox    ( WG.panelID , "WGGroupFrames"        , "Party / Raid Frame", "Enable or disable the Party / Raid Frames", function() return not WG.Save.Group.Party.Hidden end, function() WG.Save.Group.Party.Hidden = not WG.Save.Group.Party.Hidden end, false, nil)
		
		LAM:AddHeader      ( WG.panelID , "WGDefault_Frame"      , "\nDefault Frame Preferences")
		LAM:AddCheckbox    ( WG.panelID , "WGDefaultTarget"      , "Target Frame", "Enable or disable the Default Target frame.", function() return WG.Save.Default.Target end, function() WG.Save.Default.Target = not WG.Save.Default.Target end, false, nil)
		LAM:AddCheckbox    ( WG.panelID , "WGDefaultParty"       , "Party / Raid Frames", "Enable or disable the Default Party frame.", function() return WG.Save.Default.Party end, function() WG.Save.Default.Party = not WG.Save.Default.Party end, false, nil)
		
	WG.Group.PlayerSpec()
	WG.AlreadyLoaded = true
	WGDoneLoading = true
end

function WG.AddonControl()
	if ( not WGDoneLoading ) then return end
	if ( not WG.Save.Default.Target ) then
		if ( ZO_TargetUnitFramereticleover ) then
			ZO_TargetUnitFramereticleover:SetHidden ( true )	
		end
	end
	
	if ( not WG.Save.Default.Party ) then
		if ( ZO_UnitFramesGroups ) then
			ZO_UnitFramesGroups:SetHidden(true)
		end
	end
	
	if ( WG.GroupSize ~= nil and WG.GroupSize ~= GetGroupSize() ) then
		WG.Group.Left()
		WG.GroupSize = GetGroupSize()
	end
	
	WG.Character.GetTime()
	
	if ( not WG.AlreadyLoaded ) then return end
	WG.Character.CombatFade()
end

EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_ADD_ON_LOADED          , WG.AddonLoaded )
EVENT_MANAGER:RegisterForEvent ( "WarGenesisAddon" , EVENT_PLAYER_ACTIVATED       , WG.PlayerLoaded )